/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.dao;

import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableRequestDto;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Resource;
import javax.sql.DataSource;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.model.MensualidadesAExonerar;
import com.ejie.ad74a.util.UtilSQL;

/**
 * MensualidadesAExonerarDaoImpl
 * 
 * @author UDA
 */

@Repository
@Transactional
public class MensualidadesAExonerarDaoImpl implements MensualidadesAExonerarDao {

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	protected static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDLIQUIDACION", "IDSOLICITANTE", "ESTADOLIQ","IDMENSUALIDAD" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<MensualidadesAExonerar> rwMap = new RowMapper<MensualidadesAExonerar>() {
		public MensualidadesAExonerar mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			MensualidadesAExonerar mensualidadesAExonerar = new MensualidadesAExonerar();
			mensualidadesAExonerar.setIdLiquidacion(UtilSQL.getLong(resultSet, "IDLIQUIDACION"));
			mensualidadesAExonerar.setIdSolicitante(UtilSQL.getLong(resultSet,"IDSOLICITANTE"));
			mensualidadesAExonerar.setEstadoLiq(UtilSQL.getLong(resultSet, "ESTADOLIQ"));
			mensualidadesAExonerar.setIdMensualidad(UtilSQL.getLong(resultSet, "IDMENSUALIDAD"));

			return mensualidadesAExonerar;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource DataSource
	 *
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Finds a list of rows in the Cobros table.
	 *
	 * @param cobros          Cobros
	 * @param tableRequestDto TableRequestDto
	 *
	 * @return List<Cobros>
	 */
	@Transactional(readOnly = true)
	@Override
	public List<MensualidadesAExonerar> findAll(MensualidadesAExonerar mensualidadesAExonerar, TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_LIQUIDACION IDLIQUIDACION, t1.ID_SOLICITANTE IDSOLICITANTE, t1.ESTADO_LIQ ESTADOLIQ,t1.ID_MENSUALIDAD IDMENSUALIDAD ");

		// FROM
		query.append(" FROM MENSUALIDADES_A_EXONERAR t1 ");

		// WHERE clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(mensualidadesAExonerar);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query, MensualidadesAExonerarDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by the
	 * Cobros entity
	 *
	 * @param cobros Cobros Bean with the criteria values to filter by.
	 *
	 * @return Map created with two keys key query stores the sql query syntax key
	 *         params stores the parameter values to be used in the condition
	 *         sentence.
	 */
	private Map<String, ?> getWhereMap(MensualidadesAExonerar mensualidadesAExonerar) {
		StringBuilder where = new StringBuilder(MensualidadesAExonerarDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (mensualidadesAExonerar != null && mensualidadesAExonerar.getIdLiquidacion() != null) {
			where.append(" AND t1.IDLIQUIDACION = ?");
			params.add(mensualidadesAExonerar.getIdLiquidacion());
		}
		if (mensualidadesAExonerar != null && mensualidadesAExonerar.getIdSolicitante() != null) {
			where.append(" AND t1.ID_SOLICITANTE = ?");
			params.add(mensualidadesAExonerar.getIdSolicitante());
		}
		if (mensualidadesAExonerar != null && mensualidadesAExonerar.getEstadoLiq() != null) {
			where.append(" AND t1.ESTADO_LIQ = ?");
			params.add(mensualidadesAExonerar.getEstadoLiq());
		}
		if (mensualidadesAExonerar != null && mensualidadesAExonerar.getIdMensualidad() != null) {
			where.append(" AND t1.ID_MENSUALIDAD = ?");
			params.add(mensualidadesAExonerar.getIdMensualidad());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

}
